<?php

/*
 * @version     4.2.3
 * @package     com_mymaplocations
 * @copyright   JoomUnited (C) 2011. All rights reserved.
 * @license     http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * ***@author      Created by JoomUnited (C)
 */

defined('_JEXEC') or die;
jimport('joomla.version');
// import Joomla Categories Library
jimport('joomla.application.categories');
if (!(class_exists('MyMapLocationsHelper'))) {

    $helper = JPATH_SITE . '/components/com_mymaplocations/helpers/mymaplocations.php';
    if (file_exists($helper)) {
        require_once($helper);
    }
}

$lang = JFactory::getLanguage();
$app = JFactory::getApplication();
$mapid = $params->get('mapid');
$height = $params->get('height');
$width = $params->get('width');
$zoom = $params->get('zoom');
$type = $params->get('type');
$mode = $params->get('map_mode', 1);
$show_toolbar=$params->get('show_toolbar', 1);
$show_address=$params->get('show_address',1);
$order=$params->get('ordering','a.view');
$limit=$params->get('limit',0);
$userlist=$params->get('userlist','');
$map_display=$params->get('map_display',0);
 $ugroup="";
if(!empty($userlist))
{
    $db = JFactory::getDBO();
    $query = $db->getQuery(true);
    $query->select('a.*');
    $query->where('a.listid='.(int)$userlist);
    $query->from('`#__comprofiler_lists` AS a');
    $db->setQuery($query);
    $group = $db->loadObject();
    $ugroup=explode( '|*|',$group->usergroupids);
    
}
$db = JFactory::getDBO();
$query = $db->getQuery(true);
$query->select('a.*');
$query->select('k.*');
$query->select('l.username as name,k.*');
$query->select('l.name as name');
$query->where('l.block =0');
$query->where('a.latitude !=0');
$query->where('a.longitude !=0');
$query->where('k.approved =1');
$query->where('k.confirmed=1 ');
$query->where('a.state=1 ');

if(!empty($ugroup))
{
     $query->where('g.group_id IN (' . implode( ",",$ugroup) . ')');
     $cbparams=new JRegistry($group->params);
     if(!empty($group->filterfields))
     {
         $group->filterfields=MyMaplocationsHelper::utf8RawUrlDecode( substr( $group->filterfields, 1 ) );
         $group->filterfields=str_replace("'cb_","'k'.'cb_",$group->filterfields);
        $query->where($group->filterfields);
     
     }
     if (  $cbparams->get( 'filter_basic' ) ) {
			$filtering=$cbparams->get( 'filter_basic' );
                        foreach ( $filtering as $filter ) {
                                        $column					=	( isset( $filter->column ) ? $filter->column : null );
					$operator				=	( isset( $filter->operator ) ? $filter->operator : null );
					$value					=	( isset( $filter->value ) ? $filter->value : null );
                                        if ( $column && $operator ) {
                                            $column				=	$db->QuoteName( $column );
					    $escapedValue		=	 $db->escape($value, true);
                                            if ( in_array( $operator, array( 'IN', 'NOT IN||ISNULL' ) ) ) {
							$escapedValue	=	explode( ',', $escapedValue );
						} elseif ( in_array( $operator, array( 'LIKE', 'NOT LIKE||ISNULL' ) ) ) {
							$escapedValue	=	'%' . addcslashes( $escapedValue, '%_' ) . '%';
						}
                                                if ( is_array( $escapedValue ) ) {
						} else {
							$escapedValue	=	$db->Quote( $escapedValue );
						}
                                                if ( substr( $operator, -8 ) == '||ISNULL' ) {
							$operator		=	substr( $operator, 0, -8 );
							$isNull			=	true;
						} else {
							$isNull			=	false;
						}
    						$basicFilter		=	$column . ' ' . $operator . ' ' . $escapedValue;
                                                if ( ( $operator === '<>' ) && ( $value === '' ) ) {
							// Users expect a filter of not equal to empty string to also not match null (no value):
							$basicFilter	=	'( ' . $basicFilter . ' AND ' . $column . ' IS NOT NULL )';
						} elseif ( $isNull || ( ( $operator === '=' ) && ( $value === '' ) ) ) {
							// Users expect a filter of equal to empty to also match null (no value) or in the case of ISNULL operator:
							$basicFilter	=	'( ' . $basicFilter . ' OR ' . $column . ' IS NULL )';
						}
                                                $query->where($basicFilter);
                                        }
                        }
			}
			 if (  $cbparams->get( 'filter_advanced' ) ) {
				$filtering=$cbparams->get( 'filter_advanced' );
				$filtering=str_replace( array( "u", "ue" ), array( "l", "k" ),$filtering );

				$query->where($filtering);
			   }
			
}
$query->from('`#__mymaplocations_location` AS a');
$query->join('LEFT', '#__users AS l ON l.id = a.extra_id');
$query->join('LEFT','#__comprofiler AS k ON k.id = a.extra_id');
if(!empty($ugroup))
{
    $query->join('LEFT','#__user_usergroup_map AS g ON g.user_id = a.extra_id');
}
 if($order=="a.view")
 {
 $query->order('k.hits');
 }
 else
 {
 $query->order('l.registerDate');   
 }
 if($limit==0)
 {
$db->setQuery($query);
 }
 else
{
$db->setQuery($query,0,$limit);
     
 }

$result = $db->loadObjectList();
if (empty($result)) {
    return;
}
global $_CB_framework, $ueConfig, $mainframe;

if ( defined( 'JPATH_ADMINISTRATOR' ) ) {
if ( ! file_exists( JPATH_ADMINISTRATOR . '/components/com_comprofiler/plugin.foundation.php' ) ) {
echo 'CB not installed!';
return;
}
include_once( JPATH_ADMINISTRATOR . '/components/com_comprofiler/plugin.foundation.php' );
} else {
if ( ! file_exists( $mainframe->getCfg( 'absolute_path' ) . '/administrator/components/com_comprofiler/plugin.foundation.php' ) ) {
echo 'CB not installed!';
return;
}
include_once( $mainframe->getCfg( 'absolute_path' ) . '/administrator/components/com_comprofiler/plugin.foundation.php' );
}
MyMaplocationsHelper::loadLanguage();
$result[0]->google_maptype = $params->get('google_maptype', 'ROADMAP');
$result[0]->bing_maptype = $params->get('bing_maptype', 'road');
$result[0]->openmapstyle=$params->get('openmapstyle', 1);
$result[0]->map_design=$params->get('map_design', 1);
$result[0]->map_layer=$params->get('map_layer',1);
$result[0]->maplayer_url=$params->get('maplayer_url','');
$show_toolbar=$params->get('show_toolbar',1);

require JModuleHelper::getLayoutPath('mod_cb_mymaplocationsmaps', $params->get('layout', 'default'));
