<?php

/**
 * @copyright	Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.
 * @license		http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
defined('JPATH_BASE') or die;

/**
 * Supports a modal contact picker.
 *
 * @package		Joomla.Administrator
 * @subpackage	com_mymaplocations
 * @since		1.6
 */
class JFormFieldModal_location extends JFormField {

    /**
     * The form field type.
     *
     * @var		string
     * @since	1.6
     */
    protected $type = 'Modal_location';

    /**
     * Method to get the field input markup.
     *
     * @return	string	The field input markup.
     * @since	1.6
     */
    protected function getInput() {
        // Load the javascript
        JHtml::_('behavior.framework');
        JHtml::_('behavior.modal', 'a.modal');

        // Build the script.
        $script = array();
        $script[] = '	function jSelectChart_' . $this->id . '(id, name, object) {';
        $script[] = '		document.id("' . $this->id . '_id").value = id;';
        $script[] = '		document.id("' . $this->id . '_name").value = name;';
        $script[] = '		SqueezeBox.close();';
        $script[] = '	}';

        // Add the script to the document head.
        JFactory::getDocument()->addScriptDeclaration(implode("\n", $script));

        // Get the title of the linked chart
        $db = JFactory::getDBO();
        $db->setQuery(
                'SELECT name' .
                ' FROM #__mymaplocations_location' .
                ' WHERE id = ' . (int) $this->value
        );
        $title = $db->loadResult();

        if ($error = $db->getErrorMsg()) {
            JFactory::getApplication()->enqueueMessage($error,'error');
        }

        if (empty($title)) {
            $title = JText::_('COM_MYMAPLOCATIONS_SELECT_AN_STOREID');
        }

        $link = 'index.php?option=com_mymaplocations&amp;view=locations&amp;layout=modal&amp;tmpl=component&amp;function=jSelectChart_' . $this->id;
        $html = "\n" . '<div class="input-append"><input type="text" class="input-medium" id="' . $this->id . '_name" value="' . htmlspecialchars($title, ENT_QUOTES, 'UTF-8') . '" disabled="disabled" /><a class="modal btn" title="' . JText::_('COM_MYMAPLOCATIONS_SELECT_AN_STOREID') . '"  href="' . $link . '" rel="{handler: \'iframe\', size: {x: 800, y: 450}}"><i class="icon-address hasTooltip" title="' . JText::_('COM_CONTACT_CHANGE_CONTACT_BUTTON') . '"></i> ' . JText::_('JSELECT') . '</a></div>' . "\n";
        // The active contact id field.
        if (0 == (int) $this->value) {
            $value = '';
        } else {
            $value = (int) $this->value;
        }

        // class='required' for client side validation
        $class = '';
        if ($this->required) {
            $class = ' class="required modal-value"';
        }

        $html .= '<input type="hidden" id="' . $this->id . '_id"' . $class . ' name="' . $this->name . '" value="' . $value . '" />';

        return $html;
    }

}
