<?php

/**
 * @version    4.2.3
 * @package     com_mymaplocations
 * @copyright   JoomUnited (C) 2011. All rights reserved.
 * @license     http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * ****@author      joomunited - contact@joomunited.com
 */
defined('_JEXEC') or die;

/**
 * @param	array	A named array
 * @return	array
 */
function MyMaplocationsBuildRoute(&$query) {
    $segments = array();

    // get a menu item based on Itemid or currently active
    $app = JFactory::getApplication();
    $menu = $app->getMenu();
    if (empty($query['Itemid'])) {
        $menuItem = $menu->getActive();
    } else {
        $menuItem = $menu->getItem($query['Itemid']);
    }
    $mView = (empty($menuItem->query['view'])) ? null : $menuItem->query['view'];
    $mCatid = (empty($menuItem->query['catid'])) ? null : $menuItem->query['catid'];
    $mId = (empty($menuItem->query['id'])) ? null : $menuItem->query['id'];
    $segments = array();
    if (isset($query['view'])) {
        $view = $query['view'];
        //$segments[] = $view;
        unset($query['view']);
    }
    if (isset($query['task'])) {
        $segments[] = $query['task'];
        unset($query['task']);
    }
    if (isset($query['city'])) {
        $segments[] = $query['city'];
        unset($query['city']);
    }
        
    if (isset($query['layout'])) {
        $segments[] = 'location-edit';
        unset($query['layout']);
    }
    if (isset($query['id'])) {
        $id = $query['id'];
        $db = JFactory::getDBO();
        $q = 'SELECT alias FROM #__mymaplocations_location WHERE id = ' . $db->Quote($id).' AND state=1';
        $db->setQuery($q);
        $alias = $db->loadResult();
        $segments[] = $alias;
        unset($query['id']);
    }
    return $segments;
}

/**
 * @param	array	A named array
 * @param	array
 *
 * Formats:
 *
 */
function MyMaplocationsParseRoute($segments) {

    // view is always the first element of the array
    $count = count($segments);
    if($segments[0]=="location:edit")
    {
        
         $vars['view'] = "form";
         $vars['layout'] = "edit";
         if($count==2)
         {
                $slug = str_replace(":", "-", $segments[1]);
                $slug = str_replace(" ", "-", $slug);
                $db = JFactory::getDBO();
                $q = 'SELECT id FROM #__mymaplocations_location WHERE alias = ' . $db->Quote($slug).' AND state=1';
                $db->setQuery($q);
                $id = $db->loadResult();
                $vars['id'] = $id;
         }
                return $vars;
    }
    if ($count) {
        if ($count == 2) {
            $vars['view'] = $segments[0];
            if ($vars['view'] == 'locations') {
                $vars['city'] = $segments[1];
            } else {
                $slug = str_replace(":", "-", $segments[1]);
                $slug = str_replace(" ", "-", $slug);
                $db = JFactory::getDBO();
                $q = 'SELECT id FROM #__mymaplocations_location WHERE alias = ' . $db->Quote($slug).' AND state=1';
                $db->setQuery($q);
                $id = $db->loadResult();
                $vars['id'] = $id;
            }
        } else {
            $slug = str_replace(":", "-", $segments[0]);
                $slug = str_replace(" ", "-", $slug);
                $db = JFactory::getDBO();
                $q = 'SELECT id FROM #__mymaplocations_location WHERE alias = ' . $db->Quote($slug).' AND state=1';
                $db->setQuery($q);
                $id = $db->loadResult();
                $vars['id'] = $id;
                $vars['view'] = 'location';
        
        }
    }

    return $vars;
}
